const system = require("../../../system");
var settings = require("../../../../config/settings");
const querystring = require('querystring');
const AppServiceBase = require("../../app.base");
class UtilsPushService extends AppServiceBase {
  constructor() {
    super();
  };
  async pushInfo(orderResult, pobj, actionBody, opType) {
    if (orderResult.status != 0) {
      return "";
    }
    var interface_list = actionBody.product_info.interface_info;
    if (!interface_list) {
      return "";
    }
    var interface_info = null;
    var interface_list_temp = interface_list.filter(f => f.op_type == opType)
    if (interface_list_temp && interface_list_temp.length > 0) {
      interface_info = interface_list_temp[0];
    }
    if (!interface_info) {
      return "";
    }
    pobj.actionBody.add_order_info = orderResult.data;
    var refOpResult = this.reflexAction(interface_info, pobj);
    return refOpResult;
  }
  async reflexAction(interface_info, pobj) {
    var refResult = null;
    if (interface_info.interface_type == "bd") {
      if (!interface_info.method_name) {
        return system.getResult(null, "产品接口参数信息有误，20110");
      }//操作的方法名称
      var invokeObj = system.getObject(interface_info.interface_url);
      if (!invokeObj[interface_info.method_name]) {
        return system.getResult(null, "产品接口参数方法信息有误，20130");
      }
      pobj.interface_params = interface_info.params;
      var params = [pobj];
      refResult = await invokeObj[interface_info.method_name].apply(invokeObj, params);
    }
    else if (interface_info.interface_type == "yc") {

    }
    return refResult;
  }
}
module.exports = UtilsPushService;
